/**
 * @name string-range-expander
 * @fileoverview Expands string index ranges within whitespace boundaries until letters are met
 * @version 3.1.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-range-expander/}
 */

var u="3.1.3";var m=u,g={str:"",from:0,to:0,ifLeftSideIncludesThisThenCropTightly:"",ifLeftSideIncludesThisCropItToo:"",ifRightSideIncludesThisThenCropTightly:"",ifRightSideIncludesThisCropItToo:"",extendToOneSide:!1,wipeAllWhitespaceOnLeft:!1,wipeAllWhitespaceOnRight:!1,addSingleSpaceToPreventAccidentalConcatenation:!1};function y(i){let a=/^[0-9a-zA-Z]+$/;function o(n){return!n||typeof n!="string"?!1:!n.trim()}function l(n){return typeof n=="string"}if(!i||typeof i!="object"||Array.isArray(i)){let n;throw i===void 0?n="but it is missing completely.":i===null?n="but it was given as null.":n=`but it was given as ${typeof i}, equal to:
${JSON.stringify(i,null,4)}.`,new Error(`string-range-expander: [THROW_ID_01] Input must be a plain object ${n}`)}else if(typeof i=="object"&&i!==null&&!Array.isArray(i)&&!Object.keys(i).length)throw new Error("string-range-expander: [THROW_ID_02] Input must be a plain object but it was given as a plain object without any keys.");if(typeof i.from!="number")throw new Error(`string-range-expander: [THROW_ID_03] The input's "from" value resolvedOpts.from, is not a number! Currently it's given as ${typeof i.from}, equal to ${JSON.stringify(i.from,null,0)}`);if(typeof i.to!="number")throw new Error(`string-range-expander: [THROW_ID_04] The input's "to" value resolvedOpts.to, is not a number! Currently it's given as ${typeof i.to}, equal to ${JSON.stringify(i.to,null,0)}`);if(i?.str&&!i.str[i.from]&&i.from!==i.to)throw new Error(`string-range-expander: [THROW_ID_05] The given input string resolvedOpts.str ("${i.str}") must contain the character at index "from" ("${i.from}")`);if(i?.str&&!i.str[i.to-1])throw new Error(`string-range-expander: [THROW_ID_06] The given input string, resolvedOpts.str ("${i.str}") must contain the character at index before "to" ("${i.to-1}")`);if(i.from>i.to)throw new Error(`string-range-expander: [THROW_ID_07] The given "from" index, "${i.from}" is greater than "to" index, "${i.to}". That's wrong!`);if(l(i.extendToOneSide)&&i.extendToOneSide!=="left"&&i.extendToOneSide!=="right"||!l(i.extendToOneSide)&&i.extendToOneSide!==void 0&&i.extendToOneSide!==!1)throw new Error(`string-range-expander: [THROW_ID_08] The resolvedOpts.extendToOneSide value is not recognisable! It's set to: "${i.extendToOneSide}" (${typeof i.extendToOneSide}). It has to be either Boolean "false" or strings "left" or "right"`);let e={...g,...i};if(Array.isArray(e.ifLeftSideIncludesThisThenCropTightly)){let n,d;if(e.ifLeftSideIncludesThisThenCropTightly.every((f,h)=>l(f)?!0:(n=h,d=f,!1)))e.ifLeftSideIncludesThisThenCropTightly=e.ifLeftSideIncludesThisThenCropTightly.join("");else throw new Error(`string-range-expander: [THROW_ID_09] The resolvedOpts.ifLeftSideIncludesThisThenCropTightly was set to an array:
${JSON.stringify(e.ifLeftSideIncludesThisThenCropTightly,null,4)}. Now, that array contains not only string elements. For example, an element at index ${n} is of a type ${typeof d} (equal to ${JSON.stringify(d,null,0)}).`)}let t=e.str,r=e.from,s=e.to;if(e.extendToOneSide!=="right"&&(o(t[r-1])&&(o(t[r-2])||e.ifLeftSideIncludesThisCropItToo.includes(t[r-2]))||t[r-1]&&e.ifLeftSideIncludesThisCropItToo.includes(t[r-1])||e.wipeAllWhitespaceOnLeft&&o(t[r-1]))){for(let n=r;n--;)if(!e.ifLeftSideIncludesThisCropItToo.includes(t[n])){if(t[n].trim()){e.wipeAllWhitespaceOnLeft||e.ifLeftSideIncludesThisCropItToo.includes(t[n+1])?r=n+1:r=n+2;break}else if(n===0){e.wipeAllWhitespaceOnLeft?r=0:r=1;break}}}if(e.extendToOneSide!=="left"&&(o(t[s])&&(e.wipeAllWhitespaceOnRight||o(t[s+1]))||e.ifRightSideIncludesThisCropItToo.includes(t[s]))){for(let n=s,d=t.length;n<d;n++)if(!e.ifRightSideIncludesThisCropItToo.includes(t[n])&&t[n]?.trim()){e.wipeAllWhitespaceOnRight||e.ifRightSideIncludesThisCropItToo.includes(t[n-1])?s=n:s=n-1;break}}return(e.extendToOneSide!=="right"&&l(e.ifLeftSideIncludesThisThenCropTightly)&&e.ifLeftSideIncludesThisThenCropTightly&&(t[r-2]&&e.ifLeftSideIncludesThisThenCropTightly.includes(t[r-2])||t[r-1]&&e.ifLeftSideIncludesThisThenCropTightly.includes(t[r-1]))||e.extendToOneSide!=="left"&&l(e.ifRightSideIncludesThisThenCropTightly)&&e.ifRightSideIncludesThisThenCropTightly&&(t[s+1]&&e.ifRightSideIncludesThisThenCropTightly.includes(t[s+1])||t[s]&&e.ifRightSideIncludesThisThenCropTightly.includes(t[s])))&&(e.extendToOneSide!=="right"&&o(t[r-1])&&!e.wipeAllWhitespaceOnLeft&&(r-=1),e.extendToOneSide!=="left"&&o(t[s])&&!e.wipeAllWhitespaceOnRight&&(s+=1)),e.addSingleSpaceToPreventAccidentalConcatenation&&t[r-1]&&t[r-1].trim()&&t[s]&&t[s].trim()&&(!e.ifLeftSideIncludesThisThenCropTightly&&!e.ifRightSideIncludesThisThenCropTightly||!((!e.ifLeftSideIncludesThisThenCropTightly||e.ifLeftSideIncludesThisThenCropTightly.includes(t[r-1]))&&(!e.ifRightSideIncludesThisThenCropTightly||t[s]&&e.ifRightSideIncludesThisThenCropTightly.includes(t[s]))))&&(a.test(t[r-1])||a.test(t[s]))?[r,s," "]:[r,s]}export{g as defaults,y as expander,m as version};
